/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

const int m = 40000;
int t, tests;
int n, a, b, c, am, i, j, hl[100010], gl[100010], hr[100010], gr[100010], d[100010];

int main()
{
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);

    scanf("%d", &tests);
    for(t = 0; t < tests; t++)
    {
        a = 3;

        scanf("%d", &n);
        scanf("%d", &b);
        for(i = 1; i < n; i++)
        {
            scanf("%d", &c);
            d[i] = c - b;
            b = c;
        }

        am = 1;
        hl[0] = gl[0] = 0;
        for(i = 1; i < n; i++)
        {
            hl[i] = (hl[i - 1] + (d[i] % m) * am) % m;
            gl[i] = (gl[i - 1] * a  + (d[i] % m)) % m;
            am = (am * a) % m;
        }

        am = 1;
        hr[n] = gr[n] = 0;
        for(i = n - 1; i > 0; i--)
        {
            hr[i] = (hr[i + 1] + (d[i] % m) * am) % m;
            gr[i] = (gr[i + 1] * a  + (d[i] % m)) % m;
            am = (am * a) % m;
        }

        for(i = 1; i < n; i++)
            if(hl[i - 1] == gl[i - 1] && hr[i + 1] == gr[i + 1])
            {
                for(j = 1; j <= (i - 1) / 2; j++)
                    if(d[j] != d[i - j])
                        break;

                if(j <= (i - 1) / 2)
                    continue;

                for(j = 1; j <= (n - i - 1) / 2; j++)
                    if(d[i + j] != d[n - j])
                        break;

                if(j <= (n - i - 1) / 2)
                    continue;

                printf("%d\n", i);
                break;
            }

        if(i == n)
            printf("0\n");
    }

    return 0;
}






