/* GCC */

#include <iostream>
#include <fstream>

using namespace std;
const int maxn=100000;
int arr[maxn+1];
int p[maxn-1];
bool id[maxn-1];


int main(){
    ifstream fin("symmetry.in");
    ofstream fout("symmetry.out");
    
    int i, z, n, t, test;
    
    fin>>t;
    for(test=1; test<=t; test++){
        fin>>n;
        for(i=1; i<=n; i++) {
            fin>>arr[i];
        }
        for(i=1; i<=n-1; i++) {
            arr[i]=arr[i+1]-arr[i];
        }
        p[0]=-1;
        for(i=1; i<=n-1; i++){
            z=p[i-1];
            while((z>=0) && (arr[z+1]!=arr[i])) {
                z=p[z];
            }
            p[i]=z+1;
        }
        z=0;
        for(i=n-1; i>=1; i--){
            while((z>=0) && (arr[z+1]!=arr[i])) {
                z=p[z];
            }
            z++;
        }
        for(i=0; i<=n-1; i++){
            id[i]=false;
        }
        while(z>=0){
            id[z]=true;
            z=p[z];
        }
        for(i=1; i<=n-1; i++){
            z=p[i-1];
            while((z>=0) && (arr[n-z-1]!=arr[n-1])) {
                z=p[z];
            }
            p[i]=z+1;
        }
        z=0;
        for(i=1; i<=n-1; i++){
            while((z>=0) && (arr[n-z-1]!=arr[n-1])) {
                z=p[z];
            }
            z++;
        }
        i=0;
        while((z>=0) && (i==0)){
            if((z<n-1) && (id[n-z-2])) {
                i=n-z-1;
            }
            z=p[z];
        }
        fout<<i<<endl;
    }
    
    
    fin.close();
    fout.close();
    return 0;
}
