#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;

int main(){
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);
    int p1 = 47, p2 = 99993, p3 = 53, p4 = 99973;
    int t;
    scanf("%d", &t);
    for(; t > 0; t--){
        int n;
        scanf("%d", &n);
        vector<int> A; A.assign(n+1, 0);
        for(int i = 0; i < n; i++) scanf("%d", &A[i]);
        for(int i = 0; i < n-1; i++) A[i] = A[i+1] - A[i];
        //for(int i = 0; i < n; i++) printf("%d ", A[i]); printf("\n");
        int b1 = 0, b2 = 0, st = 1, b3 = 0, b4 = 0, st1 = 1;
        vector<bool> B(n+1, false);
        for(int i = n-1; i > 0; i--){
            //printf("%d %d %d\n", b1, b2, st);
            if (b1 == b2 && b3 == b4) B[i] = true;
            b1 = (b1*p1 + A[i-1]) % p2;
            b2 = (b2 + A[i-1] * st) % p2;
            st = (st*p1) % p2;
            b3 = (b3*p3 + A[i-1]) % p4;
            b4 = (b4 + A[i-1] * st1) % p4;
            st1 = (st1*p3) % p4;
        }
        //for(int i = 0; i < n; i++) printf("%d", (int)B[i]); printf("\n");
        b1 = 0; b2 = 0; st = 1; b3 = 0; b4 = 0; st1 = 1; int ans = 0;
        for(int i = 1; i < n-1; i++){
            //printf("%d %d %d\n", b1, b2, st);
            if(b1 == b2 && b3 == b4 && B[i]) {ans = i; break;}
            b1 = (b1*p1 + A[i-1]) % p2;
            b2 = (b2 + A[i-1] * st) % p2;
            st = (st*p1) % p2;
            b3 = (b3*p3 + A[i-1]) % p4;
            b4 = (b4 + A[i-1] * st1) % p4;
            st1 = (st1*p3) % p4;
        }
        //for(int i = 0; i < n-1; i++)
        printf("%d\n", ans);


    }
    fclose(stdin);
    fclose(stdout);
    return 0;
}
