/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

int s[100000], spf[100000], ss;

int pf(void)
{
	spf[0] = 0;
	for(int i = 1; i < ss; ++i)
	{
		int j = spf[i - 1];
		while(j > 0 && s[j] != s[i])
			j = spf[j - 1];
		if(s[j] == s[i])
			++j;
		spf[i] = j;
	}
	int j = 0;
    for(int i = 0; i < ss; ++i)
	{
		while(j > 0 && s[j] != s[ss - 1 - i])
			j = spf[j];
		if(s[j] == s[ss - 1 - i])
			++j;
	}
	return j;
}

int main(void)
{
	int t, n, pr, cur, ssym;
    ifstream in("symmetry.in");
    ofstream out("symmetry.out");
    in >> t;
    char lsym[100000];
    while(t--)
	{
		in >> n >> pr;
		ss = n - 1;
		for(int i = 0; i < ss; ++i, pr = cur)
		{
			in >> cur;
			s[i] = cur - pr;
		}
		ssym = pf();
		fill(lsym, lsym + n, false);
		while(ssym >= 0)
		{
            lsym[ssym] = true;
            if(ssym == 0)
				break;
			ssym = spf[ssym - 1];
		}
        reverse(s, s + ss);
        ssym = pf();
        while(ssym >= 0)
		{
            if(ssym < ss && lsym[n - 2 - ssym])
			{
				ssym = n - 1 - ssym;
				break;
			}
			if(ssym == 0)
				break;
			ssym = spf[ssym - 1];
		}
		out << ssym << '\n';
	}
    in.close();
    out.close();
    return 0;
}
