/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, m, i, j, S, M, x, v[10][16], l, r, mid, sum;
long long k, cur, L, s;
vector <int> lef, righ;
string str;

void generatel(int pos, int sum)
{
    if(pos == M)
    {
        lef.push_back(sum);

        return;
    }

    for(int i = 0; i < n; i++)
        generatel(pos + 1, sum + v[pos][i]);
}

void generater(int pos, int sum)
{
    if(pos == m)
    {
        righ.push_back(sum);

        return;
    }

    for(int i = 0; i < n; i++)
        generater(pos + 1, sum + v[pos][i]);
}

void g1(int pos, int sum)
{
    if(x - sum + 1 < 0)
        return;

    if(pos == M)
    {
        cur = cur + (lower_bound(righ.begin(), righ.end(), x - sum + 1) - lower_bound(righ.begin(), righ.end(), x - sum));
        return;
    }

    for(int i = 0; i < n; i++)
        g1(pos + 1, sum + v[pos][i]);
}

void g2(int pos, int sum)
{
    if(x - sum < 0)
        return;

    if(pos == m)
    {
        if(sum == x)
            cur++;

        return;
    }

    for(int i = 0; i < n; i++)
        g2(pos + 1, sum + v[pos][i]);
}

int main()
{
    freopen("aliens.in", "r", stdin);
    freopen("aliens.out", "w", stdout);

    scanf("%d %d %I64d", &n, &m, &k);
    for(i = 0; i < m; i++)
        for(j = 0; j < n; j++)
            scanf("%d", &v[i][j]);

    M = m - (m / 2);
    //M = (m / 2);

    generatel(0, 0);
    sort(lef.begin(), lef.end());

    generater(M, 0);
    sort(righ.begin(), righ.end());

    l = lef.back() + righ.back();
    r = lef[0] + righ[0] - 1;
    while(l - r > 1)
    {
        mid = (l + r) / 2;

        //cerr << lower_bound(righ.begin(), righ.end(), mid - lef[0] + 1) - righ.begin() << endl;

        cur = 0;
        for(i = 0; i < lef.size(); i++)
            cur = cur + (righ.size() - (lower_bound(righ.begin(), righ.end(), mid - lef[i] + 1) - righ.begin()));

        if(cur < k)
            l = mid;
        else
            r = mid;
    }

    for(i = 0; i < lef.size(); i++)
        k = k - (righ.size() - (lower_bound(righ.begin(), righ.end(), l - lef[i] + 1) - righ.begin()));

    x = l;
    s = 0;
    L = 0;
    l = 0;
    sum = 0;
    while(l < m)
    {
        s = s * n;
        s--;
        for(i = 0; i < n; i++)
        {
            s++;
            cur = 0;
            sum += v[l][i];

            if(l < M)
                g1(l + 1, sum);
            else
                g2(l + 1, sum);

            if(L + cur < k)
                L = L + cur;
            else
                break;

            sum -= v[l][i];
        }

        l++;
    }

    //cerr << s << endl;

    l = 0;
    while(l < m)
    {
        str += char(int(s % n) + int('a'));
        s = s / n;
        l++;
    }

    for(i = m - 1; i >= 0; i--)
        printf("%c", str[i]);
    printf("\n");

    return 0;
}






